<a id="types-aiobotocore-mgn"></a>

# types-aiobotocore-mgn

[![PyPI - types-aiobotocore-mgn](https://img.shields.io/pypi/v/types-aiobotocore-mgn.svg?color=blue)](https://pypi.org/project/types-aiobotocore-mgn)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-mgn.svg?color=blue)](https://pypi.org/project/types-aiobotocore-mgn)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-mgn?color=blue)](https://pypistats.org/packages/types-aiobotocore-mgn)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.mgn 2.3.4](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/mgn.html#mgn)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.11.3](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-mgn docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_mgn/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-mgn](#types-aiobotocore-mgn)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `mgn` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[mgn]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[mgn]'


# standalone installation
python -m pip install types-aiobotocore-mgn
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-mgn
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[mgn]` in your environment:

```bash
python -m pip install 'types-aiobotocore[mgn]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[mgn]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[mgn]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[mgn]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[mgn]` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[mgn]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[mgn]` in your environment:

```bash
python -m pip install 'types-aiobotocore[mgn]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[mgn]` in your environment:

```bash
python -m pip install 'types-aiobotocore[mgn]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`mgnClient` provides annotations for `session.create_client("mgn")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_mgn import mgnClient

session = get_session()
async with session.create_client("mgn") as client:
    client: mgnClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_mgn.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_mgn import mgnClient
from types_aiobotocore_mgn.paginator import (
    DescribeJobLogItemsPaginator,
    DescribeJobsPaginator,
    DescribeReplicationConfigurationTemplatesPaginator,
    DescribeSourceServersPaginator,
    DescribeVcenterClientsPaginator,
)

session = get_session()
async with session.create_client("mgn") as client:
    client: mgnClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    describe_job_log_items_paginator: DescribeJobLogItemsPaginator = client.get_paginator(
        "describe_job_log_items"
    )
    describe_jobs_paginator: DescribeJobsPaginator = client.get_paginator("describe_jobs")
    describe_replication_configuration_templates_paginator: DescribeReplicationConfigurationTemplatesPaginator = client.get_paginator(
        "describe_replication_configuration_templates"
    )
    describe_source_servers_paginator: DescribeSourceServersPaginator = client.get_paginator(
        "describe_source_servers"
    )
    describe_vcenter_clients_paginator: DescribeVcenterClientsPaginator = client.get_paginator(
        "describe_vcenter_clients"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_mgn.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_mgn.literals import (
    BootModeType,
    ChangeServerLifeCycleStateSourceServerLifecycleStateType,
    DataReplicationErrorStringType,
    DataReplicationInitiationStepNameType,
    DataReplicationInitiationStepStatusType,
    DataReplicationStateType,
    DescribeJobLogItemsPaginatorName,
    DescribeJobsPaginatorName,
    DescribeReplicationConfigurationTemplatesPaginatorName,
    DescribeSourceServersPaginatorName,
    DescribeVcenterClientsPaginatorName,
    FirstBootType,
    InitiatedByType,
    JobLogEventType,
    JobStatusType,
    JobTypeType,
    LaunchDispositionType,
    LaunchStatusType,
    LifeCycleStateType,
    ReplicationConfigurationDataPlaneRoutingType,
    ReplicationConfigurationDefaultLargeStagingDiskTypeType,
    ReplicationConfigurationEbsEncryptionType,
    ReplicationConfigurationReplicatedDiskStagingDiskTypeType,
    ReplicationTypeType,
    TargetInstanceTypeRightSizingMethodType,
    mgnServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: BootModeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_mgn.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_mgn.type_defs import (
    CPUTypeDef,
    ChangeServerLifeCycleStateSourceServerLifecycleTypeDef,
    CreateReplicationConfigurationTemplateRequestRequestTypeDef,
    DataReplicationErrorTypeDef,
    DataReplicationInfoReplicatedDiskTypeDef,
    DataReplicationInitiationStepTypeDef,
    DeleteJobRequestRequestTypeDef,
    DeleteReplicationConfigurationTemplateRequestRequestTypeDef,
    DeleteSourceServerRequestRequestTypeDef,
    DeleteVcenterClientRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    DescribeJobLogItemsRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    DescribeJobsRequestFiltersTypeDef,
    DescribeReplicationConfigurationTemplatesRequestRequestTypeDef,
    ReplicationConfigurationTemplateTypeDef,
    DescribeSourceServersRequestFiltersTypeDef,
    DescribeVcenterClientsRequestRequestTypeDef,
    VcenterClientTypeDef,
    DisconnectFromServiceRequestRequestTypeDef,
    DiskTypeDef,
    FinalizeCutoverRequestRequestTypeDef,
    GetLaunchConfigurationRequestRequestTypeDef,
    GetReplicationConfigurationRequestRequestTypeDef,
    IdentificationHintsTypeDef,
    JobLogEventDataTypeDef,
    ParticipatingServerTypeDef,
    LicensingTypeDef,
    LaunchedInstanceTypeDef,
    LifeCycleLastCutoverFinalizedTypeDef,
    LifeCycleLastCutoverInitiatedTypeDef,
    LifeCycleLastCutoverRevertedTypeDef,
    LifeCycleLastTestFinalizedTypeDef,
    LifeCycleLastTestInitiatedTypeDef,
    LifeCycleLastTestRevertedTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    MarkAsArchivedRequestRequestTypeDef,
    NetworkInterfaceTypeDef,
    OSTypeDef,
    ReplicationConfigurationReplicatedDiskTypeDef,
    RetryDataReplicationRequestRequestTypeDef,
    StartCutoverRequestRequestTypeDef,
    StartReplicationRequestRequestTypeDef,
    StartTestRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    TerminateTargetInstancesRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateReplicationConfigurationTemplateRequestRequestTypeDef,
    UpdateSourceServerReplicationTypeRequestRequestTypeDef,
    ChangeServerLifeCycleStateRequestRequestTypeDef,
    DataReplicationInitiationTypeDef,
    DescribeJobLogItemsRequestDescribeJobLogItemsPaginateTypeDef,
    DescribeReplicationConfigurationTemplatesRequestDescribeReplicationConfigurationTemplatesPaginateTypeDef,
    DescribeVcenterClientsRequestDescribeVcenterClientsPaginateTypeDef,
    EmptyResponseMetadataTypeDef,
    ListTagsForResourceResponseTypeDef,
    ReplicationConfigurationTemplateResponseMetadataTypeDef,
    DescribeJobsRequestDescribeJobsPaginateTypeDef,
    DescribeJobsRequestRequestTypeDef,
    DescribeReplicationConfigurationTemplatesResponseTypeDef,
    DescribeSourceServersRequestDescribeSourceServersPaginateTypeDef,
    DescribeSourceServersRequestRequestTypeDef,
    DescribeVcenterClientsResponseTypeDef,
    JobLogTypeDef,
    JobTypeDef,
    LaunchConfigurationTypeDef,
    UpdateLaunchConfigurationRequestRequestTypeDef,
    LifeCycleLastCutoverTypeDef,
    LifeCycleLastTestTypeDef,
    SourcePropertiesTypeDef,
    ReplicationConfigurationTypeDef,
    UpdateReplicationConfigurationRequestRequestTypeDef,
    DataReplicationInfoTypeDef,
    DescribeJobLogItemsResponseTypeDef,
    DescribeJobsResponseTypeDef,
    StartCutoverResponseTypeDef,
    StartTestResponseTypeDef,
    TerminateTargetInstancesResponseTypeDef,
    LifeCycleTypeDef,
    SourceServerResponseMetadataTypeDef,
    SourceServerTypeDef,
    DescribeSourceServersResponseTypeDef,
)


def get_structure() -> CPUTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-mgn` version is the same as related `aiobotocore` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_mgn/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
